#include "Arduino.h"
#include "string.h"
#include <Keypad.h>
#include <MFRC522.h>

#define LENGTH 4
char keys[LENGTH][LENGTH] = {
	{'1', '2', '3', 'A'},
	{'4', '5', '6', 'B'},
	{'7', '8', '9', 'C'},
	{'*', '0', '#', 'D'},
};
char rowPins[LENGTH] = {A0, A1, A2, A3};
char colPins[LENGTH] = { 6,  5,  4,  3};
Keypad keypad = Keypad(makeKeymap(keys), (byte *)rowPins, (byte *)colPins,
		LENGTH, LENGTH);

#define RST_PIN 9
#define SS_PIN 10
MFRC522 mfrc522(SS_PIN, RST_PIN);

char lastScanned[10];

void setup() {
    Serial.begin(9600);
	while (!Serial);

	pinMode(LED_BUILTIN, OUTPUT);

	SPI.begin();
	mfrc522.PCD_Init();
}

void loop() {
	char key = keypad.getKey();
	if(key) {
		Serial.write(2);
		Serial.write(key);
	}

	if (!mfrc522.PICC_IsNewCardPresent() || !mfrc522.PICC_ReadCardSerial()) {
		// If no card detected
		if (!mfrc522.PICC_IsNewCardPresent()) {
			// If lastScanned card is not empty
			if (strcmp(lastScanned, "") != 0) {
				Serial.write(0);
				Serial.write(0);
				memset(lastScanned, 0, sizeof(lastScanned[0]) * 10);
			}
		}

		delay(25);
		return;
	}
	delay(25);

	if (strcmp(lastScanned, (const char *)mfrc522.uid.uidByte) != 0) {
		Serial.write(0);
		Serial.write(1);
		delay(25);

		Serial.write(1);
		Serial.write(mfrc522.uid.uidByte, MFRC522::MF_KEY_SIZE);
		Serial.write(0);

		strcpy(lastScanned, (const char *)mfrc522.uid.uidByte);
	}

	delay(500);
}
