#include "account.h"
#include "accountpage.h"
#include "mainwindow.h"
#include "ui_mainwindow.h"

AccountPage::AccountPage() {
}

AccountPage::~AccountPage() {
}

void AccountPage::setup(MainWindow *mainWindow, Account *account) {
	m_mainWindow = mainWindow;
    m_account = account;

    QMetaObject::connectSlotsByName(this);
}

void AccountPage::onFocus() {
    loadAccounts();
}

void AccountPage::loadAccounts() {
    m_mainWindow->getUi()->accountListWidget->clear();

    for (int i = 0; i < m_account->getSize(); i++) {
        Account::Data account = m_account->getAccount(i);

        QString display = QString::number(i + 1) + ")\t" + account.number + "\t" + account.name;
        m_mainWindow->getUi()->accountListWidget->addItem(display);
    }

}

void AccountPage::on_accountListWidget_itemSelectionChanged() {
    printf("Selected: %d\n", m_mainWindow->getUi()->accountListWidget->currentRow());
}
