#ifndef CARD_H
#define CARD_H

#include <QMutex>
#include <QObject>

#include "log.h"

class Card : public QObject
{
	Q_OBJECT

public:
	Card(QThread *thread);
	~Card();

	QString getId();
	int getUserId();

	void setId(QString id);
	void setUserId(int userId);

signals:
	void finished();
	void loginUser(int);
	void emitWrongPin(bool, QString);
	void emitNewLog(Log::Type, QString, int, QString, QString);

public slots:
	void process();
	void login(QString, QString);
	void incrementFailedLogin(QString, int);
	void blockUser(QString, int);

private:
	QMutex m_mutex;

	QString m_id;
	int m_userId;

};

#endif
