#include "account.h"
#include "homepage.h"
#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "user.h"

HomePage::HomePage() {
}

HomePage::~HomePage() {
}

void HomePage::setup(MainWindow *mainWindow, User *user, Account *account) {
	m_mainWindow = mainWindow;
    m_user = user;
    m_account = account;
}

void HomePage::onFocus() {
    userLogin();
    accountSelected();
}

void HomePage::userLogin() {
    QString greeting = "Welcome, <b>" + m_user->getFirstName() + " " \
            + m_user->getLastName() + "</b>, what would you like to do today?";
	m_mainWindow->getUi()->homeLabel->setText(greeting);
}

void HomePage::accountSelected() {
    if (m_account->getActiveIndex() >= 0) {
        m_mainWindow->getUi()->homeBalanceButton->setEnabled(true);
        m_mainWindow->getUi()->homeWithdrawButton->setEnabled(true);
        m_mainWindow->getUi()->homeTransactionButton->setEnabled(true);
    }
    else {
        m_mainWindow->getUi()->homeBalanceButton->setEnabled(false);
        m_mainWindow->getUi()->homeWithdrawButton->setEnabled(false);
        m_mainWindow->getUi()->homeTransactionButton->setEnabled(false);
    }
}
