#include <QSqlQuery>
#include <QThread>

#include "card.h"
#include "db.h"
#include "log.h"

Log::Log(QThread *thread, Card *card) :
    m_card(card)
{
	this->moveToThread(thread);
	QObject::connect(thread,	&QThread::started,  this,	&Log::process);
	QObject::connect(this,		&Log::finished,	    thread,	&QThread::quit);
	QObject::connect(this,		&Log::finished,	    this,	&Log::deleteLater);
	QObject::connect(thread,	&QThread::finished,	thread,	&QThread::deleteLater);

	qRegisterMetaType<Log::Type>("Log::Type");
}

Log::~Log() {
}

void Log::process() {
}

void Log::newLog(Log::Type type, QString value, int success,
        QString fromAccountNumber, QString toAccountNumber) {
    int userId = m_card->getUserId();
	QString timestamp = QDateTime::currentDateTime().toString("yyyy-MM-dd HH:mm:ss");

    QSqlQuery query = Db::q("INSERT INTO `log` (`user_id`, `type`, \
            `value`, `success`, `from_account_number`, `to_account_number`, \
            `timestamp`) VALUES (?, ?, ?, ?, ?, ?, ?)",
            {userId, (int)type, value, success, fromAccountNumber, toAccountNumber, timestamp});
    query.exec();
}
