#ifndef LOG_H
#define LOG_H

#include <QDateTime>
#include <QMutex>
#include <QObject>

class Card;

class Log : public QObject
{
	Q_OBJECT

public:
	Log(QThread *thread, Card *card);
	~Log();

	enum Type {
		LOGIN,
		LOGOUT,
		PAGE_VISIT,
		TRANSACTION,
	};

signals:
	void finished();

public slots:
	void process();
	void newLog(Log::Type, QString, int, QString, QString);

private:
	QMutex m_mutex;

	Card *m_card;

};

#endif
