#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QMutex>

#include "log.h"

class SerialCommand;
class Card;
class User;
class Account;
class Transaction;

namespace Ui {
	class MainWindow;
}

class MainWindow : public QMainWindow
{
	Q_OBJECT

public:
	MainWindow(SerialCommand *serialCommand, Card *card, User *user,
			Account *account, Log *log, Transaction *transaction);
	~MainWindow();

	enum WindowState {
		LOGIN_PAGE,
		HOME_PAGE,
		ACCOUNT_PAGE,
		BALANCE_PAGE,
		WITHDRAW_PAGE,
		TRANSFER_PAGE,
	};

	Ui::MainWindow *getUi();
	WindowState getWindowState();

signals:
	void emitNewLog(Log::Type, QString, int, QString, QString);

public slots:
	void setWindowState(MainWindow::WindowState);

private slots:

private:
	QMutex m_mutex;

	Ui::MainWindow *m_ui;
	WindowState m_windowState;

	Log *m_log;

	bool m_afterLogin;

};

#endif
