#ifndef SERIAL_H
#define SERIAL_H

// Uno
// 10755
// 67
// 115200
// Nano
// 6790
// 29987
// 9600
#define VENDOR_IDENTIFIER 6790
#define PRODUCT_IDENTIFIER 29987
#define SERIAL_BAUD_RATE 9600

#include <QMutex>
#include <QSerialPort>
#include <QSerialPortInfo>

class Serial : public QObject
{
	Q_OBJECT

public:
	Serial(QThread *thread);
	~Serial();
	bool initSerial();

	bool getConnected();

signals:
	void finished();
	void sendData(QByteArray);

public slots:
	void process();
	void readData();
	void processError();

private:
	QMutex m_mutex;

	bool m_connected;
	QByteArray m_data;
	QSerialPort *m_serialPort;
	QString m_serialPortName;

};

#endif
