#ifndef TRANSACTION_H
#define TRANSACTION_H

#include <QMutex>
#include <QObject>

#include "log.h"

class Account;

class Transaction : public QObject
{
	Q_OBJECT

public:
	Transaction(QThread *thread, Account *account);
	~Transaction();
	bool withdraw(qint64 amount, int id, bool add = false);

signals:
	void finished();
	void emitWithdrawAttempt(bool, QString);
	void emitTransferAttempt(bool, QString);
	void emitNewLog(Log::Type, QString, int, QString, QString);

public slots:
	void process();
	void transfer(qint64, QString);

private:
	QMutex m_mutex;

	Account *m_account;

};

#endif
