#ifndef USER_H
#define USER_H

#include <QMutex>
#include <QObject>

class User : public QObject
{
	Q_OBJECT

public:
	User(QThread *thread);
	~User();

	int getId();
	QString getFirstName();
	QString getLastName();
	int getRole();

	void setId(int id);
	void setFirstName(QString firstName);
	void setLastName(QString lastName);
	void setRole(int role);

signals:
	void finished();
	void setAccounts(int);
	void emitLogin();

public slots:
	void process();
	void login(int);

private:
	QMutex m_mutex;

	int m_id;
	QString m_firstName;
	QString m_lastName;
	int m_role;

};

#endif
