#include "account.h"
#include "mainwindow.h"
#include "transaction.h"
#include "ui_mainwindow.h"
#include "withdrawpage.h"

WithdrawPage::WithdrawPage() {
}

WithdrawPage::~WithdrawPage() {
}

void WithdrawPage::setup(MainWindow *mainWindow, Account *account, Transaction *transaction) {
	m_mainWindow = mainWindow;
    m_account = account;
	m_transaction = transaction;

	connect(m_transaction, &Transaction::emitWithdrawAttempt, this, &WithdrawPage::withdrawAttempt);
}

void WithdrawPage::onFocus() {
	// Reset ui
	numberEntered(0);
	withdrawAttempt(true, "");
}

void WithdrawPage::numberEntered(qint64 amount) {
	m_mainWindow->getUi()->withdrawDisplay->setText(Account::formatCurrency(amount * FACTOR));
}

void WithdrawPage::withdrawAttempt(bool success, QString message) {
	if (!success) {
		m_mainWindow->getUi()->withdrawDisplay->setStyleSheet("border: 1px solid red; \
				border-radius: 5px;");
		m_mainWindow->getUi()->withdrawMessage->setText(message);
	}
	else {
		m_mainWindow->getUi()->withdrawDisplay->setStyleSheet("border: 1px solid rgb(48, 52, 64); \
				border-radius: 5px;");
		m_mainWindow->getUi()->withdrawMessage->setText(message);
	}

	numberEntered(0);
}
